(function(window,document){
    
	//ヘッダ伸縮メニュー
    var _toggleMenuButton = document.getElementById( 'main-nav-button' );
	var _closeMenuButton = document.getElementById( 'main-nav-button-close' );
    var _toggleMenu = document.getElementById( 'navbarHeader' );
	var _htmlStyle = document.documentElement.style;
	var _theBody = document.getElementsByTagName( 'body' )[0];
    
	init_menubutton();
	
	
    function init_menubutton() {
        _clientH = _toggleMenu.clientHeight;
		if( window.innerWidth < 768 ){
			_toggleMenu.classList.add( 'close' );
		}
        _toggleMenuButton.addEventListener( 'click', function(){ openMenu(); }, false);
		
		_closeMenuButton.addEventListener( 'click', function(){ closeMenu(); }, false );
		
		_toggleMenu.addEventListener( 'keydown', function( event ) { navbar_focus_control( event ); }, false );
		
    }
	
	
	
	//あける(最初から表示されてるボタン)
    function openMenu() {
		if( _toggleMenu.classList.contains( 'close' ) ) {
			_toggleMenu.classList.remove( 'close' );
			_toggleMenu.classList.add( 'open' );
			
			Object.keys( htmlStyles() ).forEach( function( styleKey ) {
				_htmlStyle.setProperty( styleKey, htmlStyles()[ styleKey ] );
			} );
			
			get_navbar_elements()[0].focus();
			
		} else {
			//しめる(いらんかも)
			closeMenu();
		}
    }
	//しめる(メニュー内のボタン)
	function closeMenu() {
		_toggleMenu.classList.remove( 'open' );
		_toggleMenu.classList.add( 'close' );
		
		Object.keys( htmlStyles() ).forEach( function( styleKey ) {
			_htmlStyle.removeProperty( styleKey );
		} );
		
		_toggleMenuButton.focus();
	}
	
	//キーボードフォーカスをメニュー内に限定する
	function navbar_focus_control( event ) {
		if( _toggleMenu.classList.contains( 'open' ) ) {
			
			//最初と最後の要素を決定
			theLastElement = get_navbar_elements()[ elements.length - 1 ];
			theFirstElement = elements[0];
		
			tabKey = event.keyCode === 9;
			shiftKey = event.shiftKey;
			
			if ( ! shiftKey && tabKey && theLastElement === document.activeElement ) {
					event.preventDefault();
					theFirstElement.focus();
			}

			if ( shiftKey && tabKey && theFirstElement === document.activeElement ) {
				event.preventDefault();
				theLastElement.focus();
			}
			
		}	
	}
	//要素リストとる
	function get_navbar_elements() {
		selectors = 'input, a, button';
		elements = _toggleMenu.querySelectorAll( selectors );
		return elements;
	}
	//HTMLに足すスタイル(裏のスクロール制御)
	function htmlStyles() {
		var adminBarHeight = '0';
		if ( _theBody.classList.contains( 'admin-bar' ) ) {
			adminBarHeight = '-46px';
		}
		return {
			visibility: 'hidden',
			position: 'fixed',
			width: '100%',
			top: adminBarHeight
		};
	}
	
	//リサイズ時の処理
    window.addEventListener( 'resize', function() {
        if( window.innerWidth > 767 ){
			_toggleMenu.classList.remove( 'open' );
			_toggleMenu.classList.remove( 'close' );
			
			Object.keys( htmlStyles() ).forEach( function( styleKey ) {
				_htmlStyle.removeProperty( styleKey );
			} );
			
        } else {
			_toggleMenu.classList.add( 'close' );
			//リサイズ後ウインドウはとじる
		}
    }, false );
	
	
	
})(window,document);


