<?php
global $post;
$slider_display = get_theme_mod( 'istk_portfolio_slider_on_off', 'off' );
$slider_images = get_theme_mod( 'istk_portfolio_slider_image' );

if ( ( $slider_display === 'on' ) || ( !empty( get_header_image() ) ) ) {
	echo '<div id="front-main-image-area">';
}

if ( ( $slider_display === 'on' ) && ( !empty( $slider_images ) ) ){
	//カルーセル
	?>
	
	<!-- Slider main container -->
<div class="swiper-container">
  <!-- Additional required wrapper -->
  <div class="swiper-wrapper">
    <!-- Slides -->
	<?php
		foreach ( $slider_images as $img_url ) {
			//image
			$img_id = attachment_url_to_postid( $img_url );
			if( $img_id != 0 ) {
				$img = wp_get_attachment_image( $img_id, 'istk_portfolio_head_img' );
			} else {
				$img = '<img src="' . $img_url . '" class="fullsize">';
			}
			echo '<div class="swiper-slide"><div class="inside">' . wp_kses_post( $img ) . '</div></div>';
		}
	?>
  </div>
  <!-- If we need pagination -->
  <div class="swiper-pagination"></div>

  <!-- If we need navigation buttons -->
  <div class="swiper-button-prev"></div>
  <div class="swiper-button-next"></div>

  <!-- If we need scrollbar -->
  <div class="swiper-scrollbar"></div>
</div>
	
	
<?php
} elseif ( ( $slider_display === 'off' ) && ( !empty( get_header_image() ) ) ) {
	//ヘッダーイメージを表示
	?><div class="main-head-image"><?php
	if( isset( get_custom_header()->attachment_id ) ) {
		echo wp_get_attachment_image( get_custom_header()->attachment_id, array( 1280, 600 ) );
	} else {
		?>
		<img src="<?php header_image(); ?>" height="<?php echo esc_attr( get_custom_header()->height ); ?>" width="<?php echo esc_attr( get_custom_header()->width ); ?>" alt="ISTK Portfolio" /><?php
	}
	?></div><?php
}


if ( ( $slider_display === 'on' ) || ( !empty( get_header_image() ) ) ) {
	echo '</div><!-- // #front-main-image-area -->';
}
?>


